package sach.eventmodel;


import java.util.EventListener;

/**
 * Spoločný interface pre všetky listenery v aplikácii
 * @author Adam Netočný
 */
public interface TahListener extends EventListener {
    /**
     * Volaná pri prijatí události typu ťah
     * @param event Daná udalosť
     */
    public void tah(TahEvent event);
    
    /**
     * Volaná pri prijatí události typu chybný ťah
     * @param event Daná udalosť
     */
    public void chybyTah(TahEvent event);

    /**
     * Volaná pri prijatí události typu výber figúrky
     * @param event Daná udalosť
     */
    public void vyberFigurku(TahEvent event);

    /**
     * Volaná pri prijatí události typu chybová hláška
     * @param event Daná udalosť
     */
    public void chyba(TahEvent event);

    /**
     * Volaná pri prijatí události typu šach
     * @param event Daná udalosť
     */
    public void sach(TahEvent event);

    /**
     * Volaná pri prijatí události typu mat
     * @param event Daná udalosť
     */
    public void mat(TahEvent event);
}
