package sach.gui;

import sach.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

/**
 * Dialog pre About...
 * @author Adam Netočný
 */
class AboutDialog extends JDialog {
    /**
     * Konštruktor - vytvorí dialog
     */
    public AboutDialog() {
        super(MainFrame.me, "About Šach", true);
        
        this.setBounds(135, 100, 280, 105);
        setLocationRelativeTo(MainFrame.me);
        setResizable(false);
        setIconImage(createImageIcon("biele/kon.png").getImage());
        setLayout(null);

        final JDialog me = this;

        JLabel img = new JLabel(createImageIcon("cierne/kon.png"));
        JTextArea text = new JTextArea("Šach v 1.0\n\rSemestrálna práca - Y36PJV");
        text.setBorder(BorderFactory.createLineBorder(Color.black));
        text.setEditable(false);
        JButton btn = new JButton("Close");
        btn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                me.setVisible(false);
            }
        });
        
        add(img);
        add(text);
        add(btn);

        img.setBounds(0, 0, 70, 70);
        text.setBounds(85, 5, 185, 35);
        btn.setBounds(190, 45, 80, 25);

    }

    /**
     * Získa adresu zdroja a výtvorí z neho ImageIcon
     * @param path Lokálna adresa zdroja
     * @return ImageIcon vytvorený z daného zdroja
     */
    private ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = SachApp.class.getResource("resources/" + path);
        return new ImageIcon(imgURL);
    }

    
}