package sach.gui;

import sach.logic.Figurka;
import sach.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

/**
 * Dialóg pre výber figúrky, ked pešiak dôjde na koniec poľa
 * @author Adam Netočný
 */
class ChooseFigurka extends JDialog {
    /**
     * Uchováva návratovú hodnotu dialógu
     */
    private Figurka.Type result;

    /**
     * Konštruktor - vytvorí dialog
     * @param farba Farba, v ktorej majú byť zobrazené figúrky na tlačítkach
     */
    public ChooseFigurka(Figurka.Color farba) {
        super(MainFrame.me, "Vyberte figurku, ktorou chcete nahradit pesiaka....", true);
        
        this.setBounds(110, 100, 330, 145);
        setLocationRelativeTo(MainFrame.me);
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setIconImage(createImageIcon("biele/kon.png").getImage());
        setLayout(null);

        final JDialog me = this;

        JLabel txt = new JLabel("Vyberte figurku, ktorou chcete nahradit pesiaka:");
        JButton kon = new JButton(createImageIcon((farba==Figurka.Color.biela)? "biele/kon.png" : "cierne/kon.png"));
        kon.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                result = Figurka.Type.kon;
                me.setVisible(false);
            }
        });

        JButton strelec = new JButton(createImageIcon((farba==Figurka.Color.biela)? "biele/strelec.png" : "cierne/strelec.png"));
        strelec.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                result = Figurka.Type.strelec;
                me.setVisible(false);
            }
        });

        JButton veza = new JButton(createImageIcon((farba==Figurka.Color.biela)? "biele/veza.png" : "cierne/veza.png"));
        veza.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                result = Figurka.Type.veza;
                me.setVisible(false);
            }
        });

        JButton dama = new JButton(createImageIcon((farba==Figurka.Color.biela)? "biele/dama.png" : "cierne/dama.png"));
        dama.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                result = Figurka.Type.dama;
                me.setVisible(false);
            }
        });

        add(txt);
        add(kon);
        add(strelec);
        add(veza);
        add(dama);

        txt.setBounds(5, 5, 300, 20);
        txt.setHorizontalAlignment(JLabel.CENTER);

        kon.setBounds(5, 30, 75, 75);
        strelec.setBounds(85, 30, 75, 75);
        veza.setBounds(165, 30, 75, 75);
        dama.setBounds(245, 30, 75, 75);
    }

    /**
     * Vráti užvateľovu voľbu
     * @return Typ figúrky, ktorú zvolil užívateľ
     */
    public Figurka.Type getResult(){
        return this.result;
    }

    /**
     * Získa adresu zdroja a výtvorí z neho ImageIcon
     * @param path Lokálna adresa zdroja
     * @return ImageIcon vytvorený z daného zdroja
     */
    private ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = SachApp.class.getResource("resources/" + path);
        return new ImageIcon(imgURL);
    }
}
