package sach.gui;

import sach.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Dialóg pre výber IP adresy/Host Name servru
 * @author Adam Netočný
 */
class IPChooser extends JDialog {
    /**
     * Uchováva užívaťeľovú voľbu
     */
    private String ipHost;

    /**
     * Vytvorí dialóg pre výber IP adresy/Host Name servru
     */
    public IPChooser() {
        super(MainFrame.me, "IP adresa servra....", true);
        
        this.setBounds(135, 100, 250, 125);
        setLocationRelativeTo(MainFrame.me);
        setResizable(false);
        setIconImage(createImageIcon("biele/kon.png").getImage());
        setLayout(null);

        final JDialog me = this;

        JLabel txt = new JLabel("Zadajte IP adresu/Hostname servru:");
        final JTextField host = new JTextField();
        host.addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(KeyEvent e) {
                if(e.getKeyCode() == KeyEvent.VK_ENTER){
                    ipHost = host.getText();
                    me.setVisible(false);
                }
            }
        });

        JButton btn = new JButton("OK");
        btn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ipHost = host.getText();
                me.setVisible(false);
            }
        });

        add(txt);
        add(host);
        add(btn);

        txt.setBounds(5, 5, 240, 20);
        txt.setHorizontalAlignment(JLabel.CENTER);

        host.setBounds(5, 30, 230, 20);
        host.setHorizontalAlignment(JLabel.CENTER);

        btn.setBounds(155, 60, 80, 25);

    }

    /**
     * Získa adresu zdroja a výtvorí z neho ImageIcon
     * @param path Lokálna adresa zdroja
     * @return ImageIcon vytvorený z daného zdroja
     */
    private ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = SachApp.class.getResource("resources/" + path);
        return new ImageIcon(imgURL);
    }

    /**
     * Vrácia uživateľom zvolenú IP adresu/Host Name servru
     * @return IP adresa/Host Name servru
     */
    public String getIPHost(){
        return ipHost;
    }

}
