package sach.gui;


import sach.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * Dialóg pre zobrazenie ovládania a JavaDoc dokumentu
 * @author Adam Netočný
 */
class JavaDocBrowser extends JDialog implements HyperlinkListener {
    /**
     * Uchováva odkaz na komponent náhľadu
     */
    private JEditorPane htmlPane;
    
    /**
     * Vytvorí dialóg pre zobrazenie ovládania a JavaDoc dokumentu
     */
    public JavaDocBrowser() {
        super(MainFrame.me, "Help a JavaDoc", true);

        this.setBounds(110, 100, 700, 550);

        setLocationRelativeTo(MainFrame.me);

        setIconImage(createImageIcon("biele/kon.png").getImage());

        java.net.URL url = SachApp.class.getResource("resources/javadoc/help.html");
        try {
            htmlPane = new JEditorPane(url);
            htmlPane.setEditable(false);
            htmlPane.addHyperlinkListener(this);
            JScrollPane scrollPane = new JScrollPane(htmlPane);
            getContentPane().add(scrollPane, BorderLayout.CENTER);
        } catch(IOException ioe) {
        }
    }

    /**
     * Získa adresu zdroja a výtvorí z neho ImageIcon
     * @param path Lokálna adresa zdroja
     * @return ImageIcon vytvorený z daného zdroja
     */
    private ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = SachApp.class.getResource("resources/" + path);
        return new ImageIcon(imgURL);
    }

    /**
     * Uskutočňuje zmenu URL náhľadu v prípade že to užívateľ požaduje
     * @param event Samotný odkaz na event
     */
    public void hyperlinkUpdate(HyperlinkEvent event) {
        if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
          try {
            htmlPane.setPage(event.getURL());
          } catch(IOException ioe) { }
        }
    }


}
