package sach.gui;

import sach.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Dialógové okno zobrazované pri posielaní dát medzi servrom a klientom
 * @author Adam Netočný
 */
class SendReciveDialog extends JDialog {
    /**
     * Vytvorí dialóg
     */
    public SendReciveDialog() {
        super(MainFrame.me, "Prijma a odosiela data....", false);
        final SendReciveDialog me = this;
        
        setBounds(0, 0, 250, 165);
        setLocationRelativeTo(MainFrame.me);
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setIconImage(createImageIcon("biele/kon.png").getImage());
        setLayout(null);

        JProgressBar pgb = new JProgressBar();
        pgb.setValue(0);
        JLabel txt = new JLabel("Prijma a odosiela data....");
        JLabel txt2 = new JLabel("Prosim cakajte.");

        JButton btn = new JButton("Cancel");
        btn.getInputMap().put(KeyStroke.getKeyStroke("SPACE"),
                            "none");
        btn.getInputMap().put(KeyStroke.getKeyStroke("released SPACE"),
                            "none");
        btn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int res = JOptionPane.showConfirmDialog(MainFrame.me, "Naozaj si prajete prerusit prenos?\n" +
                        "Znamenalo by to ukoncenie hry.", "Sach", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                if(res == JOptionPane.YES_OPTION){
                    me.setVisible(false);
                    SachApp.me.exit();
                }
            }
        });

        add(txt);
        add(txt2);
        add(pgb);
        add(btn);

        txt.setBounds(5, 5, 240, 20);
        txt.setHorizontalAlignment(JLabel.CENTER);

        txt2.setBounds(5, 30, 240, 20);
        txt2.setHorizontalAlignment(JLabel.CENTER);

        pgb.setBounds(5, 80, 230, 20);
        pgb.setIndeterminate(true);

        btn.setBounds(155, 105, 80, 25);
    }

    /**
     * Zobrazí okno a zacentruje ho na stred hlavného okna
     * @param b true - zobrazit; false - skryť
     */
    @Override
    public void setVisible(boolean b) {
        super.setVisible(b);
        setLocationRelativeTo(MainFrame.me);
    }



    /**
     * Získa adresu zdroja a výtvorí z neho ImageIcon
     * @param path Lokálna adresa zdroja
     * @return ImageIcon vytvorený z daného zdroja
     */
    private ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = SachApp.class.getResource("resources/" + path);
        return new ImageIcon(imgURL);
    }
}
