package sach.logic;

/**
 * Kontajner pre ukladanie vyhodených figúriek
 * @author Adam Netočný
 */
public class VyhodeneKontajner {
    /**
     * Pole obsahujúce biele figúrky
     */
    private FigurkaInterface[] stratBiele;

    /**
     * Pole obsahujúce čierne figúrky
     */
    private FigurkaInterface[] stratCierne;
    
    /**
     * Počet bielých figúriek v poli
     */
    private int biele;

    /**
     * Počet čierných figúriek v poli
     */
    private int cierne;

    /**
     * Vytvorí prázdny kontajner pre 15 figúriek z každej farby
     */
    public VyhodeneKontajner() {
        stratBiele = new FigurkaInterface[15];
        stratCierne = new FigurkaInterface[15];
        biele = 0;
        cierne = 0;
    }

    /**
     * Vloži figúrku do kontajneru
     * @param fig Figúrka, ktorú má vložiť
     */
    public void vloz(FigurkaInterface fig){
        if(fig.getColor()==Figurka.Color.biela){
            stratBiele[biele]=fig;
            biele++;
        } else {
            stratCierne[cierne]=fig;
            cierne++;
        }
    }

    /**
     * Vracia počet uložených čierných figúriek
     * @return Počet uložených čierných figúriek
     */
    public int getCierneLength(){
        return cierne;
    }

    /**
     * Vracia počet uložených bielých figúriek
     * @return Počet uložených bielých figúriek
     */
    public int getBieleLength(){
        return biele;
    }

    /**
     * Vracia čiernu figúrku
     * @param index Index figúrky, na ktorom je uložená
     * @return Čierna figúrka na danom indexom
     */
    public FigurkaInterface getCiernuAt(int index){
        return stratCierne[index];
    }

    /**
     * Vracia bielu figúrku
     * @param index Index figúrky, na ktorom je uložená
     * @return Biela figúrka na danom indexom
     */
    public FigurkaInterface getBieluAt(int index){
        return stratBiele[index];
    }
}
