package sach.file;

import java.io.BufferedReader;
import sach.logic.Figurka;
import java.io.File;
import java.io.FileReader;
import org.junit.Test;
import sach.eventmodel.*;
import sach.logic.GameStatus;
import sach.logic.Point;
import static org.junit.Assert.*;

public class ZapisTahovUnitTest {
    private GameStatus st;

    private class Handler extends TahHandler {
        private int potvrdenie = 0;
        @Override
        public void tah(TahEvent event) {
        }

        @Override
        public void chybyTah(TahEvent event) {
        }

        @Override
        public void vyberFigurku(TahEvent event) {
            if(!event.equals(this.event)){
                if(event.getTypFig() == null){
                    fireVyberFigurku(event.getOdkial(), event.getKam(), Figurka.Type.dama, event.getFarba());
                } else {
                    fireVyberFigurku(event.getOdkial(), event.getKam(), event.getTypFig(), event.getFarba());
                }
            }
        }

        @Override
        public void chyba(TahEvent event) {
           if(!event.equals(this.event)){
                fireChyba(event.getChyba());
            }
        }

        @Override
        public void sach(TahEvent event) {
            if(!event.equals(this.event)){
                fireSach(event.getFarba());
            }
        }

        @Override
        public void mat(TahEvent event) {
            if(!event.equals(this.event)){
                fireMat(event.getFarba());
            }
        }

        public void tah(Point a, Point b) throws InterruptedException{
            fireTah(a, b, Figurka.Color.biela);
        }
        public void fChyba() throws InterruptedException{
            fireChyba("Chyba");
        }
    };
    
    @Test
    public void zapisTah() throws Throwable{
        ZapisTahov zp = new ZapisTahov();
        File f = new File(zp.getFilePath());
        assertEquals(f.length(), (long)0);

        Handler th = new Handler();

        th.addTahListener(zp);
        zp.addTahListener(th);

        th.tah(new Point(3, 2), new Point(63));
        th.fChyba();

        zp.finalize();
        
        f = new File(zp.getFilePath());
        assertTrue(f.length()!=0);
        FileReader fr = new FileReader(f);
        BufferedReader br = new BufferedReader(fr);

        String line = br.readLine();
        assertEquals(line, "C5 -> H1; Farba: biela");
        line = br.readLine();
        assertEquals(line, "\tChyba: Chyba");

        fr.close();
        br.close();
    }
}
