package sach.logic;

import sach.logic.Pesiak;
import sach.logic.FigurkaInterface;
import sach.logic.Kon;
import org.junit.Test;
import static org.junit.Assert.*;
import sach.logic.Figurka.PesiakNaKonciPola;
import sach.logic.Figurka.Rozsada;

public class KonUnitTest {

    @Test
    public void tah() throws PesiakNaKonciPola, Rozsada{
        /*| |0 |1 |2 |3 |4 |5 |6 |7 |
          --------------------------|
          |0|  |KB|  |  |  |  |  |  |
          |1|  |  |  |PB|  |  |  |  |
          |2|PC|  |X |X |  |  |  |  |
          |3|  |  |  |  |  |  |  |  |
          |4|  |  |  |  |  |  |  |  |
          |5|  |  |  |  |  |  |  |  |
          |6|  |  |  |  |  |  |  |  |
          |7|  |  |  |  |  |  |  |  |
         V-veza
         K-kon
         S-strelec
         D-dama
         P-pesiak
         KR-kral

         B-biela farba
         C-cierna farba
         */
        FigurkaInterface[][] pole = new FigurkaInterface[8][8];

        Kon kon = new Kon(0, 1, Figurka.Color.biela);
        pole[0][1] = kon;
        
        pole[1][3] = new Pesiak(1, 3, Figurka.Color.biela);

        pole[2][0] = new Pesiak(2, 0, Figurka.Color.cierna);

        assertEquals(kon.getX(), 0);
        assertEquals(kon.getY(), 1);
        assertEquals(kon.tah(2, 2, pole), true);
        assertEquals(kon.getX(), 0);
        assertEquals(kon.getY(), 1);
        assertEquals(kon.tah(2, 3, pole), false);
        assertEquals(kon.getX(), 0);
        assertEquals(kon.getY(), 1);
        assertEquals(kon.tah(-2, 8, pole), false);
        assertEquals(kon.getX(), 0);
        assertEquals(kon.getY(), 1);
        assertEquals(kon.tah(1, 3, pole), false);
        assertEquals(kon.getX(), 0);
        assertEquals(kon.getY(), 1);
        assertEquals(kon.tah(2, 0, pole), true);
        kon.setXY(2,0);
        assertEquals(kon.getX(), 2);
        assertEquals(kon.getY(), 0);
    }
}
