package sach.logic;

import sach.logic.Pesiak;
import sach.logic.FigurkaInterface;
import sach.logic.Strelec;
import org.junit.Test;
import static org.junit.Assert.*;
import sach.logic.Figurka.PesiakNaKonciPola;
import sach.logic.Figurka.Rozsada;

public class StrelecUnitTest {

    @Test
    public void tah() throws Rozsada, PesiakNaKonciPola{
        /*| |0 |1 |2 |3 |4 |5 |6 |7 |
          --------------------------|
          |0|PB|  |  |  |  |  |PB|  |
          |1|  |X |  |  |  |X |  |  |
          |2|  |  |  |  |  |  |  |  |
          |3|  |  |  |SB|  |X |  |  |
          |4|  |  |  |  |  |  |X |  |
          |5|  |PC|  |  |  |PB|  |  |
          |6|X |  |  |  |  |  |X |  |
          |7|  |  |  |  |  |  |  |  |
         V-veza
         K-kon
         S-strelec
         D-dama
         P-pesiak
         KR-kral

         B-biela farba
         C-cierna farba
         */
        FigurkaInterface[][] pole = new FigurkaInterface[8][8];

        Strelec strelec = new Strelec(3, 3, Figurka.Color.biela);
        pole[3][3] = strelec;
        
        pole[0][0] = new Pesiak(0, 0, Figurka.Color.biela);
        pole[0][6] = new Pesiak(0, 6, Figurka.Color.biela);
        pole[5][5] = new Pesiak(5, 5, Figurka.Color.biela);

        pole[5][1] = new Pesiak(5, 1, Figurka.Color.cierna);

        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(1, 1, pole), true);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(0, 0, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(-2, 8, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(5, 5, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(1, 5, pole), true);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(5, 1, pole), true);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(6, 0, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(0, 6, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(3, 5, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(4, 6, pole), false);
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(6, 6, pole), false);
        pole[5][5] = null;
        assertEquals(strelec.getX(), 3);
        assertEquals(strelec.getY(), 3);
        assertEquals(strelec.tah(6, 6, pole), true);
        strelec.setXY(2,0);
        assertEquals(strelec.getX(), 2);
        assertEquals(strelec.getY(), 0);
    }
}
